-- Unique Faction ID
local factionid = "Sergal";
print ("Loading "..factionid)

CF_Factions[#CF_Factions + 1] = factionid
	
-- Faction name
CF_FactionNames[factionid] = "Sergal";
-- Faction description
CF_FactionDescriptions[factionid] = "A low-tech high-impact faction with a focus on close combat. Commonly found as budget-price mercenaries.";
-- Set true if faction is selectable by player or AI
CF_FactionPlayable[factionid] = true;

-- Modules needed for this faction
CF_RequiredModules[factionid] = {"Base.rte", "Sergal.rte"}

-- Set faction nature
CF_FactionNatures[factionid] = CF_FactionTypes.ORGANIC;


-- Define faction bonuses, in percents
CF_ScanBonuses[factionid] = 0
CF_RelationsBonuses[factionid] = 0
CF_ExpansionBonuses[factionid] = 40

CF_MineBonuses[factionid] = 10
CF_LabBonuses[factionid] = 0
CF_AirfieldBonuses[factionid] = 0
CF_SuperWeaponBonuses[factionid] = 0
CF_FactoryBonuses[factionid] = 10
CF_CloneBonuses[factionid] = 30
CF_HospitalBonuses[factionid] = 0

-- Define brain unit
CF_Brains[factionid] = "Advisor";
CF_BrainModules[factionid] = "Sergal.rte";
CF_BrainClasses[factionid] = "AHuman";
CF_BrainPrices[factionid] = 250;

-- Define dropship	
CF_Crafts[factionid] = "Sergal Small Rocket", "Sergal Large Rocket";
CF_CraftModules[factionid] = "Sergal.rte";
CF_CraftClasses[factionid] = "ACRocket";
CF_CraftPrices[factionid] = 120;

-- Define superweapon script
CF_SuperWeaponScripts[factionid] = "UnmappedLands2.rte/SuperWeapons/Bombing.lua"

-- Define buyable actors available for purchase or unlocks
CF_ActNames[factionid] = {}
CF_ActPresets[factionid] = {}
CF_ActModules[factionid] = {}
CF_ActPrices[factionid] = {}
CF_ActDescriptions[factionid] = {}
CF_ActUnlockData[factionid] = {}
CF_ActClasses[factionid] = {}
CF_ActTypes[factionid] = {}
CF_ActPowers[factionid] = {}
CF_ActOffsets[factionid] = {}

local i = 0
i = #CF_ActNames[factionid] + 1
CF_ActNames[factionid][i] = "Soldier"
CF_ActPresets[factionid][i] = "Soldier"
CF_ActModules[factionid][i] = "Sergal.rte"
CF_ActPrices[factionid][i] = 30
CF_ActDescriptions[factionid][i] = "The least of the sergal ranks. They are usually sent in droves."
CF_ActUnlockData[factionid][i] = 0
CF_ActTypes[factionid][i] = CF_ActorTypes.LIGHT;
CF_ActPowers[factionid][i] = 7

i = #CF_ActNames[factionid] + 1
CF_ActNames[factionid][i] = "Warrior"
CF_ActPresets[factionid][i] = "Warrior"
CF_ActModules[factionid][i] = "Sergal.rte"
CF_ActPrices[factionid][i] = 70
CF_ActDescriptions[factionid][i] = "Warriors form the bulk of any Sergal force. Just be sure to let them know who is in charge."
CF_ActUnlockData[factionid][i] = 500
CF_ActTypes[factionid][i] = CF_ActorTypes.LIGHT;
CF_ActPowers[factionid][i] = 5

i = #CF_ActNames[factionid] + 1
CF_ActNames[factionid][i] = "Scout"
CF_ActPresets[factionid][i] = "Scout"
CF_ActModules[factionid][i] = "Sergal.rte"
CF_ActPrices[factionid][i] = 80
CF_ActDescriptions[factionid][i] = "A Sergaelic scout is great with speed and durability. Not so great in grueling gunfights however."
CF_ActUnlockData[factionid][i] = 500
CF_ActTypes[factionid][i] = CF_ActorTypes.LIGHT;
CF_ActPowers[factionid][i] = 5

i = #CF_ActNames[factionid] + 1
CF_ActNames[factionid][i] = "Guardian"
CF_ActPresets[factionid][i] = "Guardian"
CF_ActModules[factionid][i] = "Sergal.rte"
CF_ActPrices[factionid][i] = 90
CF_ActDescriptions[factionid][i] = "Guardians are the strongest of the lower ranks. Only Sergals with years of combat experience gain access to full-body armour."
CF_ActUnlockData[factionid][i] = 2000
CF_ActTypes[factionid][i] = CF_ActorTypes.HEAVY;
CF_ActPowers[factionid][i] = 5

i = #CF_ActNames[factionid] + 1
CF_ActNames[factionid][i] = "Medic"
CF_ActPresets[factionid][i] = "Medic"
CF_ActModules[factionid][i] = "Sergal.rte"
CF_ActPrices[factionid][i] = 100
CF_ActDescriptions[factionid][i] = "Medic soldier of the Sergal army. Wears heavy medical backpack, so don't give him too many guns."
CF_ActUnlockData[factionid][i] = 0
CF_ActTypes[factionid][i] = CF_ActorTypes.LIGHT;
CF_ActPowers[factionid][i] = 5

i = #CF_ActNames[factionid] + 1
CF_ActNames[factionid][i] = "Gun Platform"
CF_ActPresets[factionid][i] = "Gun Platform"
CF_ActModules[factionid][i] = "Sergal.rte"
CF_ActPrices[factionid][i] = 100
CF_ActDescriptions[factionid][i] = "A low-tech armored platform on 4 legs.  Remotely controlled, and sporting a light machine gun. Represents a massive leap in sergaelic technical achievments."
CF_ActUnlockData[factionid][i] = 1500
CF_ActClasses[factionid][i] = "ACrab"
CF_ActTypes[factionid][i] = CF_ActorTypes.ARMOR;
CF_ActPowers[factionid][i] = 3
CF_ActOffsets[factionid][i] = Vector(0,12)

i = #CF_ActNames[factionid] + 1
CF_ActNames[factionid][i] = "Commando"
CF_ActPresets[factionid][i] = "Commando"
CF_ActModules[factionid][i] = "Sergal.rte"
CF_ActPrices[factionid][i] = 140
CF_ActDescriptions[factionid][i] = "Guardians are the strongest of the lower ranks. Only Sergals with years of combat experience gain access to full-body armour."
CF_ActUnlockData[factionid][i] = 2000
CF_ActTypes[factionid][i] = CF_ActorTypes.HEAVY;
CF_ActPowers[factionid][i] = 5

-- Define buyable items available for purchase or unlocks
CF_ItmNames[factionid] = {}
CF_ItmPresets[factionid] = {}
CF_ItmModules[factionid] = {}
CF_ItmPrices[factionid] = {}
CF_ItmDescriptions[factionid] = {}
CF_ItmUnlockData[factionid] = {}
CF_ItmClasses[factionid] = {}
CF_ItmTypes[factionid] = {}
CF_ItmPowers[factionid] = {}

local i = 0
i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Shovel"
CF_ItmPresets[factionid][i] = "Shovel"
CF_ItmModules[factionid][i] = "Ronin.rte"
CF_ItmPrices[factionid][i] = 3
CF_ItmDescriptions[factionid][i] = "Ronin's resource collection and bashing device #1."
CF_ItmUnlockData[factionid][i] = 0
CF_ItmTypes[factionid][i] = CF_WeaponTypes.DIGGER;
CF_ItmPowers[factionid][i] = 2

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Light Digger"
CF_ItmPresets[factionid][i] = "Light Digger"
CF_ItmModules[factionid][i] = "Base.rte"
CF_ItmPrices[factionid][i] = 10
CF_ItmDescriptions[factionid][i] = "Lightest in the digger family. Cheapest of them all and works as a nice melee weapon on soft targets."
CF_ItmUnlockData[factionid][i] = 100
CF_ItmTypes[factionid][i] = CF_WeaponTypes.DIGGER;
CF_ItmPowers[factionid][i] = 1

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Medium Digger"
CF_ItmPresets[factionid][i] = "Medium Digger"
CF_ItmModules[factionid][i] = "Base.rte"
CF_ItmPrices[factionid][i] = 40
CF_ItmDescriptions[factionid][i] = "Stronger digger. This one can pierce rocks with some effort and dig impressive tunnels and its melee weapon capabilities are much greater."
CF_ItmUnlockData[factionid][i] = 500
CF_ItmTypes[factionid][i] = CF_WeaponTypes.DIGGER;
CF_ItmPowers[factionid][i] = 1

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Sergal Spear"
CF_ItmPresets[factionid][i] = "Sergal Spear"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 0
CF_ItmDescriptions[factionid][i] = "The ancient traditional weapon of the sergal race. Many keep these as souvenirs and heirlooms."
CF_ItmUnlockData[factionid][i] = 0
CF_ItmTypes[factionid][i] = CF_WeaponTypes.TOOL;
CF_ItmPowers[factionid][i] = 1

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Sergal Sword"
CF_ItmPresets[factionid][i] = "Sergal Sword"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 10
CF_ItmDescriptions[factionid][i] = "The sergaelic relic sword is a rare sight, as the sergals themselves usually prefer polearms instead."
CF_ItmUnlockData[factionid][i] = 0
CF_ItmTypes[factionid][i] = CF_WeaponTypes.TOOL;
CF_ItmPowers[factionid][i] = 1

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Sergal Shield"
CF_ItmPresets[factionid][i] = "Sergal Shield"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 10
CF_ItmDescriptions[factionid][i] = "Sergalic shields are as expected; Light, tough, but not completely unpenetrable."
CF_ItmUnlockData[factionid][i] = 0
CF_ItmClasses[factionid][i] = "HeldDevice"
CF_ItmTypes[factionid][i] = CF_WeaponTypes.SHIELD;
CF_ItmPowers[factionid][i] = 3

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Sergal Hand Cannon"
CF_ItmPresets[factionid][i] = "Sergal Hand Cannon"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 70
CF_ItmDescriptions[factionid][i] = "Utilising the same type of firing mechanism from the Sergaelic shotgun, the power in this pistol is rediculous. Highly accurate and damaging, this gun is somewhat limited by it's small ammo slot and tendency to explode if someone so much as breathes on it."
CF_ItmUnlockData[factionid][i] = 0
CF_ItmTypes[factionid][i] = CF_WeaponTypes.PISTOL;
CF_ItmPowers[factionid][i] = 7

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Sergal Rifle"
CF_ItmPresets[factionid][i] = "Sergal Rifle"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 60
CF_ItmDescriptions[factionid][i] = "The first projectile weapon of the Sergal race, once highly valued for their loud noises they make. Dangerous in the right hands, though somewhat lacking in comparison to other race equivilants due to their power and weight."
CF_ItmUnlockData[factionid][i] = 0
CF_ItmTypes[factionid][i] = CF_WeaponTypes.RIFLE;
CF_ItmPowers[factionid][i] = 10

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Sergal SMG"
CF_ItmPresets[factionid][i] = "Sergal SMG"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 60
CF_ItmDescriptions[factionid][i] = "Has a decent stopping power on low distances, but poor accuracy and rate of fire compared to it's counterparts."
CF_ItmUnlockData[factionid][i] = 0
CF_ItmTypes[factionid][i] = CF_WeaponTypes.RIFLE;
CF_ItmPowers[factionid][i] = 10

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Sergal Mitrailleuse"
CF_ItmPresets[factionid][i] = "Sergal Mitrailleuse"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 45
CF_ItmDescriptions[factionid][i] = "Powerful, rapidfire weapon. Great for clearing hallways."
CF_ItmUnlockData[factionid][i] = 0
CF_ItmTypes[factionid][i] = CF_WeaponTypes.RIFLE;
CF_ItmPowers[factionid][i] = 10

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Sergal Assault Rifle"
CF_ItmPresets[factionid][i] = "Sergal Assault Rifle"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 75
CF_ItmDescriptions[factionid][i] = "Further development of auto Sergal weaponry. Plenty of stopping power."
CF_ItmUnlockData[factionid][i] = 500
CF_ItmTypes[factionid][i] = CF_WeaponTypes.RIFLE;
CF_ItmPowers[factionid][i] = 10

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Sergal Shock Rifle"
CF_ItmPresets[factionid][i] = "Sergal Shock Rifle"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 80
CF_ItmDescriptions[factionid][i] = "Faster firing than the Assault variant, but has a more complex reload system. Meant for sudden and short engagements."
CF_ItmUnlockData[factionid][i] = 500
CF_ItmTypes[factionid][i] = CF_WeaponTypes.RIFLE;
CF_ItmPowers[factionid][i] = 10

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Sergal Fireworks Launcher"
CF_ItmPresets[factionid][i] = "Fireworks Launcher"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 70
CF_ItmDescriptions[factionid][i] = "Especially deadly against organic targets."
CF_ItmUnlockData[factionid][i] = 0
CF_ItmTypes[factionid][i] = CF_WeaponTypes.PISTOL;
CF_ItmPowers[factionid][i] = 7

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Sergal Auto Cannon"
CF_ItmPresets[factionid][i] = "Sergal Auto Cannon"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 100
CF_ItmDescriptions[factionid][i] = "The highest rifle-related tech acheivement of the Sergal race. A burst fire version of the current standard issue Sergaelic rifle."
CF_ItmUnlockData[factionid][i] = 1000
CF_ItmTypes[factionid][i] = CF_WeaponTypes.RIFLE;
CF_ItmPowers[factionid][i] = 6

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Sergal Shotgun"
CF_ItmPresets[factionid][i] = "Sergal Shotgun"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 80
CF_ItmDescriptions[factionid][i] = "The first of the newer Sergal tech. A shotgun that is incredibly devastating within short range, but slow to use and has crazy recoil. Filled with explosives for the extra kick that Sergals love so much, so just be careful using it around precarious edges."
CF_ItmUnlockData[factionid][i] = 0
CF_ItmTypes[factionid][i] = CF_WeaponTypes.SHOTGUN;
CF_ItmPowers[factionid][i] = 8

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Sergal Lance Shotgun"
CF_ItmPresets[factionid][i] = "Sergal Lance Shotgun"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 180
CF_ItmDescriptions[factionid][i] = "Traditional Sergal short-medium range weapon. These things are pretty rare nowadays, but it is still powerful and effective."
CF_ItmUnlockData[factionid][i] = 1000
CF_ItmTypes[factionid][i] = CF_WeaponTypes.SHOTGUN;
CF_ItmPowers[factionid][i] = 8

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Sergal Sniper Rifle"
CF_ItmPresets[factionid][i] = "Sergal Sniper Rifle"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 150
CF_ItmDescriptions[factionid][i] = "Essentially a powered-up Sergaelic rifle with a longer barrel and smaller magazine. Not very accurate."
CF_ItmUnlockData[factionid][i] = 2000
CF_ItmTypes[factionid][i] = CF_WeaponTypes.SNIPER;
CF_ItmPowers[factionid][i] = 6

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Sergal RocketLauncher"
CF_ItmPresets[factionid][i] = "Sergal RocketLauncher"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 240
CF_ItmDescriptions[factionid][i] = "The pinnacle of Sergal explosives. Fires a small propelled rocket that explodes if it flies for too long."
CF_ItmUnlockData[factionid][i] = 3000
CF_ItmTypes[factionid][i] = CF_WeaponTypes.HEAVY;
CF_ItmPowers[factionid][i] = 5

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Recoilless Rifle"
CF_ItmPresets[factionid][i] = "Recoilless Rifle"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 300
CF_ItmDescriptions[factionid][i] = "A shoulder mounted, powerful artillery weapon."
CF_ItmUnlockData[factionid][i] = 3000
CF_ItmTypes[factionid][i] = CF_WeaponTypes.HEAVY;
CF_ItmPowers[factionid][i] = 5

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Sergal GrenadeLauncher"
CF_ItmPresets[factionid][i] = "Sergal GrenadeLauncher"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 120
CF_ItmDescriptions[factionid][i] = "Sergals love explosions. Don't fire this too close to your target."
CF_ItmUnlockData[factionid][i] = 1500
CF_ItmTypes[factionid][i] = CF_WeaponTypes.HEAVY;
CF_ItmPowers[factionid][i] = 6

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Sergal MiniRocketLauncher"
CF_ItmPresets[factionid][i] = "Sergal GrenadeLauncher"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 180
CF_ItmDescriptions[factionid][i] = "Powerful, rapidfire weapon. Great for clearing hallways."
CF_ItmUnlockData[factionid][i] = 2500
CF_ItmTypes[factionid][i] = CF_WeaponTypes.HEAVY;
CF_ItmPowers[factionid][i] = 3

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Offhand Sergal MiniRocketLauncher"
CF_ItmPresets[factionid][i] = "Offhand Sergal MiniRocketLauncher"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 180
CF_ItmDescriptions[factionid][i] = "Combine with non-offhand MRLauncher for double the fireworks."
CF_ItmUnlockData[factionid][i] = 2500
CF_ItmClasses[factionid][i] = "HeldDevice"
CF_ItmTypes[factionid][i] = CF_WeaponTypes.SHIELD;
CF_ItmPowers[factionid][i] = 2

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Offhand Sergal Mitrailleuse"
CF_ItmPresets[factionid][i] = "Offhand Sergal Mitrailleuse"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 180
CF_ItmDescriptions[factionid][i] = "Combine with non-offhand Mitrailleuse for double the firepower."
CF_ItmUnlockData[factionid][i] = 100
CF_ItmClasses[factionid][i] = "HeldDevice"
CF_ItmTypes[factionid][i] = CF_WeaponTypes.SHIELD;
CF_ItmPowers[factionid][i] = 2

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Sergal Grenade"
CF_ItmPresets[factionid][i] = "Sergal Grenade"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 10
CF_ItmDescriptions[factionid][i] = "An improvised explosive, utilising the explosive shells from the Sergaelic shotgun."
CF_ItmUnlockData[factionid][i] = 0
CF_ItmClasses[factionid][i] = "TDExplosive"
CF_ItmTypes[factionid][i] = CF_WeaponTypes.GRENADE;
CF_ItmPowers[factionid][i] = 7

i = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][i] = "Sergaelic Trap"
CF_ItmPresets[factionid][i] = "Sergaelic Trap"
CF_ItmModules[factionid][i] = "Sergal.rte"
CF_ItmPrices[factionid][i] = 20
CF_ItmDescriptions[factionid][i] = "A dangerous trap, usually set by the crafty. When set off, it has enough strength to remove the legs of almost any humanoid!"
CF_ItmUnlockData[factionid][i] = 0
CF_ItmClasses[factionid][i] = "TDExplosive"
CF_ItmTypes[factionid][i] = CF_WeaponTypes.GRENADE;
CF_ItmPowers[factionid][i] = 7

